package com.kingdee.eas.custom.shuiyou.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.bsf.service.app.IHRMsfService;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.shr.compensation.SubmitStatusEnum;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordEntryFactory;
import com.kingdee.shr.compensation.app.incomeTax.TaxPersonRecordEntryInfo;
import org.apache.log4j.Logger;

import java.util.Map;

public class PersonnelReportService implements IHRMsfService {
    private static Logger logger = Logger.getLogger("com.kingdee.eas.custom.shuiyou.service.PersonnelReportService");
    @Override
    public Object process(Context context, Map map) throws EASBizException, BOSException {
        logger.error("com.kingdee.eas.custom.shuiyou.service.PersonnelReportService.process");
        Object o = map.get("result");
        if (o == null) {
            throw new RuntimeException("resultΪ");
        }
        JSONObject jsonObject = JSONObject.parseObject(o.toString());
        logger.error("Σ"+jsonObject);
        JSONObject body = jsonObject.getJSONObject("body");
        JSONArray bsjgs = body.getJSONArray("bsjg");
        for (int b = 0; b < bsjgs.size(); b++) {
            JSONObject bsjg = bsjgs.getJSONObject(b);
            String nsrsbh = bsjg.getString("nsrsbh");
            TaxPersonRecordEntryInfo taxPersonRecordEntry =
                    TaxPersonRecordEntryFactory.getLocalInstance(context).
                            getTaxPersonRecordEntryInfo("select * , bill.* where taxNumber = '" + nsrsbh + "'");
            String sbzt = bsjg.getString("sbzt");//״̬ 1	 2	 3	ʧ 4	ɹ
            taxPersonRecordEntry.setSubmitStatus(StartReflection(sbzt));
            bsjg.getString("rzzt");//֤״̬0	֤״̬Ϊ֤У֤Ϊݲ֤ 1	֤ͨ 2	֤ͨ 4	֤ 9	ͬ0
            //bsjg.getString("sfyjd");//Ƿ񽨵
            String sbyy = bsjg.getString("sbyy");//ʧԭ
            taxPersonRecordEntry.setFailReason(sbyy);
            BOSUuid id = taxPersonRecordEntry.getId();
            TaxPersonRecordEntryFactory.getLocalInstance(context).update(new ObjectUuidPK(id),taxPersonRecordEntry);
        }
        return null;
    }
    public SubmitStatusEnum StartReflection(String start){
        switch (start){
            case "1":
                return SubmitStatusEnum.NotSubmit;
            case "2":
                return SubmitStatusEnum.Submiting;
            case "3":
                return SubmitStatusEnum.SubmitFail;
            case "4":
                return SubmitStatusEnum.HaveSubmit;
        }
        return null;
    }
}
